program main
  use sep
  implicit none


  integer :: nx, ny, nz, nhx, nhy
  real    :: ox, oy, oz, ohx, ohy
  real    :: dx, dy, dz, dhx, dhy
  integer :: ix, iy, iz, ngap, nwnd1,nwnd2,np,ip,pz,px,py
  real    :: z, zmin, zmax, dist

  real, dimension(:,:,:,:,:), allocatable :: mod1, mod2
  real,  dimension(:,:),allocatable         ::picks

  call initpar()

  call from_history("n1", nhx); call from_history("o1", ohx); call from_history("d1", dhx)
  call from_history("n2", nhy); call from_history("o2", ohy); call from_history("d2", dhy)
  call from_history("n3", nx ); call from_history("o3", ox ); call from_history("d3", dx )
  call from_history("n4", ny ); call from_history("o4", oy ); call from_history("d4", dy )
  call from_history("n5", nz ); call from_history("o5", oz ); call from_history("d5", dz )

  call from_aux("picks","n2",np)


  call from_param("ngap", ngap, 1 )
  call from_param("zmin", zmin, oz)
  call from_param("zmax", zmax, oz+(nz-1)*dz)
  call from_param("nwnd1", nwnd1, 0 )
  call from_param("nwnd2", nwnd2, 0 )
  


  allocate(mod1(nhx,nhy,nx,ny,nz))
  allocate(mod2(nhx,nhy,nx,ny,nz),picks(3,np))

  call sreed("picks",picks,4*3*np)

     mod1 = 0.
     mod2 = 0. 
     call sep_read(mod1)

do ip=1,np
!write(0,*) real(ip/ngap*ngap)
   if (ip/ngap*ngap==ip .or. ip==1 ) then
      pz=(picks(1,ip)-oz)/dz +1
      px=(picks(2,ip)-ox)/dx +1
      py=(picks(3,ip)-oy)/dy +1
write(0,*) ip,px,py,pz+nwnd1
     do ix=-1*(nwnd2),(nwnd2)
      do iz=-1*(nwnd1),(nwnd1)
       !dist=sqrt(real(ix*ix + iz*iz))
       !write(0,*) ix,dist
       mod2(:,:,px+ix,py,pz+iz) = mod1(:,:,px+ix,py,pz+iz)   !*exp(-3*dist)
      end do
     end do
   end if
end do


 call sep_write(mod2)


end program
