program Focus_meas
  !      

  use sep
  implicit none

  integer :: nt, nx,nh,ix,it,ih
  real:: dt,dx,dh,t0,x0,h0,t1,x1,hmax,hval,asum,atot,alpha
  real,  dimension(:,:,:),allocatable                                ::input
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init(SOURCE)


  call from_history("n1",nt); call from_history("n2",nx); call from_history("n3",nh)
  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dh)
  call from_history("o1",t0); call from_history("o2",x0); call from_history("o3",h0)
  ! call from_history("n3",ny);
  write(0,*) 'n1/n2',nt,nx
  call from_param("alpha",alpha,1.)

  allocate(input(nt,nx,nh))
  write(0,*) 'after allocations'
  call sep_read(input)

  write(0,*) 'read in data'
  asum=0.
  hmax=max(abs(h0),abs(h0+(nh-1)*dh))
  atot=sum(abs(input))
  do ih=1,nh
   hval=h0+(ih-1)*dh
   do ix=1,nx
    do it=1,nt
      asum=asum+abs(input(it,ix,ih))*exp(alpha*hval/hmax)  
    end do
   end do
  end do   
  write(0,*) 'Focusing measure:',atot/asum


end program 
