program Focus_meas
  !      

  use sep
  implicit none

  integer :: nz, nx, ny, nhx, nhy, ix,iz,iy,ihx,ihy,ierr
  real    :: hmax,hval,asum,atot,alpha,hdist,hx0,hy0,dhx,dhy
  real,  dimension(:,:,:,:,:),allocatable             ::img
  character(len=256)                         :: inpt_
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init(SOURCE)


  call from_history("n1",nhx); call from_history("n2",nhy); call from_history("n3",nx); call from_history("n4",ny);call from_history("n5",nz)
  call from_history("d1",dhx); call from_history("d2",dhy)
  call from_history("o1",hx0); call from_history("o2",hy0) 
  ! call from_history("n3",ny);
  !write(0,*) 'n1/n2',nt,nx
  call from_param("alpha",alpha,1.)
  inpt_="input"
  allocate(img(nhx,nhy,nx,ny,nz))
  write(0,*) 'after allocations'
  call sep_read(img)

  write(0,*) 'read in data'
  asum=0.
  hmax=sqrt( (max(abs(hx0),abs(hx0+(nhx-1)*dhx)))**2 + (max(abs(hy0),abs(hy0+(nhy-1)*dhy)))**2   )
  atot=0.
  atot=sum(abs(img))
write(0,*) nhx,nhy,nx,ny,nz,atot

  do iz=1,nz
 if (mod(iz,100)==0) write(0,*) iz
   
   do iy=1,ny
  
     do ix=1,nx
      !call sreed_window(inpt_,5,(/nhx,nhy,nx,ny,nz/),(/nhx,nhy,1,1,1/),(/0,0,ix-1,iy-1,iz-1/),(/1,1,1,1,1/),4,img)
      !write (0,*) ix
      do ihy=1,nhy
       do ihx=1,nhx
         hval= sqrt( (hx0+(ihx-1)*dhx)**2 + (hy0+(ihy-1)*dhy)**2 )
         asum=asum+abs(img(ihx,ihy,ix,iy,iz))*exp(alpha*hval/hmax)
         !atot=atot+sum(abs(img)) 
       end do
     end do 
    end do
   end do
  end do   
  write(0,*) 'Focusing measure:',atot/asum


end program 
