program Focus_meas
  !      

  use sep
  use igrad2

  implicit none

  integer :: nt, nx,nh,ix,it,ih, iz0,ierr
  real:: dt,dx,dh,t0,x0,h0,t1,x1,hmax,hval,asum,atot,alpha,imgmean, varsum=0
  real,  dimension(:,:,:),allocatable                                ::input
  real,  dimension(:,:),allocatable                                ::z0,z0grad1,z0grad2
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init(SOURCE)


  call from_history("n1",nt); call from_history("n2",nx); call from_history("n3",nh)
  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dh)
  call from_history("o1",t0); call from_history("o2",x0); call from_history("o3",h0)
  ! call from_history("n3",ny);
  write(0,*) 'n1/n2',nt,nx
  call from_param("alpha",alpha,1.)

  allocate(input(nt,nx,nh),z0(nt,nx),z0grad1(nt,nx),z0grad2(nt,nx))
  
  write(0,*) 'after allocations'
  call sep_read(input)
  
  input = input / maxval(input)

  iz0= -1* (h0/dh)   
write(0,*) 'zero-offset at ih=',iz0
  z0 = abs(input(:,:,iz0+1))
  write(0,*) 'read in data'

 ! Image Variance
 
  imgmean= sum(z0) / (nt*nx)

  do ix=1,nx
    do it=1,nt
     varsum=varsum + ( z0(it,ix) - imgmean )**2
    end do
  end do

  write(0,*) 'Variance:',varsum

  ! Gradient norm

 do it=1,nt
  ierr = igrad2_lop(.false.,.false.,z0(it,:),z0grad1(it,:))
 end do

 do ix=1,nx
   ierr = igrad2_lop(.false.,.false.,z0(:,ix),z0grad2(:,ix))
 end do

 write(0,*)'L1 of gradient:',sum(z0grad1+z0grad2)
 write(0,*)'L2 of gradient:',sum(z0grad1**2+z0grad2**2)
 write(0,*)'Avg value:',imgmean

  asum=0.
  hmax=max(abs(h0),abs(h0+(nh-1)*dh))
  atot=sum(abs(input))
  do ih=1,nh
   hval=h0+(ih-1)*dh
   do ix=1,nx
    do it=1,nt
      asum=asum+abs(input(it,ix,ih))*exp(alpha*hval/hmax)  
    end do
   end do
  end do   
  write(0,*) 'Focusing measure:',atot/asum


end program 
