program Focus_meas
  !      

  use sep
  use igrad2

  implicit none

  integer :: nz, nx, ny, nhx, nhy, ix,iz,iy,ihx,ihy,ierr,iz0x,iz0y
  real    :: hmax,hval,asum,atot,alpha,hdist,hx0,hy0,dhx,dhy,varsum=0,imgmean
  real,  dimension(:,:,:,:,:),allocatable             ::img
  real,  dimension(:,:,:),allocatable             ::z0,z0grad1,z0grad2
  character(len=256)                         :: inpt_
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init(SOURCE)


  call from_history("n1",nhx); call from_history("n2",nhy); call from_history("n3",nx); call from_history("n4",ny);call from_history("n5",nz)
  call from_history("d1",dhx); call from_history("d2",dhy)
  call from_history("o1",hx0); call from_history("o2",hy0) 
  ! call from_history("n3",ny);
  !write(0,*) 'n1/n2',nt,nx
  call from_param("alpha",alpha,1.)
  inpt_="input"
  allocate(img(nhx,nhy,nx,ny,nz),z0(nx,ny,nz),z0grad1(nx,ny,nz),z0grad2(nx,ny,nz))
  write(0,*) 'after allocations'
  call sep_read(img)

  write(0,*) 'read in data'


  iz0x= -1* (hx0/dhx) 
  iz0y = -1* (hy0/dhy)  
write(0,*) 'zero-offset at ih=',iz0x,iz0y
  z0 = abs(img(iz0x+1,iz0y+1,:,:,:))
  z0 = z0 / maxval(z0)
  write(0,*) 'read in data'

 ! Image Variance
 
  imgmean= sum(z0) / (nz*nx*ny)

  do iz=1,nz
    do iy=1,ny
     do ix=1,nx
     varsum=varsum + ( z0(ix,iy,iz) - imgmean )**2
     end do
    end do
  end do

  write(0,*) 'Variance:',varsum

  ! Gradient norm

do iy=1,ny
 do iz=1,nz
  ierr = igrad2_lop(.false.,.false.,z0(:,iy,iz),z0grad1(:,iy,iz))
 end do

 do ix=1,nx
   ierr = igrad2_lop(.false.,.false.,z0(ix,iy,:),z0grad2(ix,iy,:))
 end do
end do

 write(0,*)'L1 of gradient:',sum(z0grad1+z0grad2)
 write(0,*)'L2 of gradient:',sum(z0grad1**2+z0grad2**2)
 write(0,*)'Avg value:',imgmean

  asum=0.
  hmax=sqrt( (max(abs(hx0),abs(hx0+(nhx-1)*dhx)))**2 + (max(abs(hy0),abs(hy0+(nhy-1)*dhy)))**2   )
  atot=0.
  atot=sum(abs(img))
write(0,*) nhx,nhy,nx,ny,nz,atot

  do iz=1,nz
 if (mod(iz,100)==0) write(0,*) iz
   
   do iy=1,ny
  
     do ix=1,nx
      !call sreed_window(inpt_,5,(/nhx,nhy,nx,ny,nz/),(/nhx,nhy,1,1,1/),(/0,0,ix-1,iy-1,iz-1/),(/1,1,1,1,1/),4,img)
      !write (0,*) ix
      do ihy=1,nhy
       do ihx=1,nhx
         hval= sqrt( (hx0+(ihx-1)*dhx)**2 + (hy0+(ihy-1)*dhy)**2 )
         asum=asum+abs(img(ihx,ihy,ix,iy,iz))*exp(alpha*hval/hmax)
         !atot=atot+sum(abs(img)) 
       end do
     end do 
    end do
   end do
  end do   
  write(0,*) 'Focusing measure:',atot/asum


end program 
