program main
  use sep
  implicit none


  integer :: nx, ny, nz, nhx, nhy
  real    :: ox, oy, oz, ohx, ohy
  real    :: dx, dy, dz, dhx, dhy
  integer :: ix, iy, iz, ngap, nwnd
  real    :: z, zmin, zmax

  real, dimension(:,:,:,:), allocatable :: mod1, mod2

  call initpar()

  call from_history("n1", nhx); call from_history("o1", ohx); call from_history("d1", dhx)
  call from_history("n2", nhy); call from_history("o2", ohy); call from_history("d2", dhy)
  call from_history("n3", nx ); call from_history("o3", ox ); call from_history("d3", dx )
  call from_history("n4", ny ); call from_history("o4", oy ); call from_history("d4", dy )
  call from_history("n5", nz ); call from_history("o5", oz ); call from_history("d5", dz )


  call from_param("ngap", ngap, 1 )
  call from_param("zmin", zmin, oz)
  call from_param("zmax", zmax, oz+(nz-1)*dz)
  call from_param("nwnd", nwnd, 0 )


  allocate(mod1(nhx,nhy,nx,ny))
  allocate(mod2(nhx,nhy,nx,ny))

  do iz=1, nz
     z = oz+(iz-1)*dz
     mod1 = 0.
     mod2 = 0. 
     call sep_read(mod1)
     do iy=1, ny
     do ix=1, nx
        if (ix/ngap*ngap==ix .and. z>=zmin .and. z<=zmax) then
           mod2(:,:,ix-nwnd:ix+nwnd,iy) = mod1(:,:,ix-nwnd:ix+nwnd,iy) 
        end if
     end do
     end do  
     call sep_write(mod2)
  end do


  


end program
